/*
**
*******************************************************************************
**
**				Copyright (c) 2005 - Atmel Corporation
**				L
**
** 	: AT90CAN128/ATmega88グ
** 	: hall_sensor_ISR.c
** 	: A荞ݻٰ
**
** :		t:			:		:
** 1.0		2005N6		F.G.		쐬
** 1.1		2006N7		F.G.		ǂ̂߉
** 1.2		2007N5		F.G.		GCC߲׎xǉ
**
**				ȉ˭ނݒ肳ׂłB:-
**
**  -
**
** ATMEL - 2005
** SĂ̿ĳ ۸т͂ǂ̎̕ۏ؂Ȃ'󂻂̂܂'Œ񋟂܂BATMEL
** ͂ǂ̖ړIɑ΂Ă񋟂ꂽޗ̓K錾܂BATMEL͑SĂ̈Î
** Iȕۏ؁A̖ړIA\ANQɑ΂K܂݁A񋟂ꂽĳ
** ɊւSĂ̕ۏ؂Əłf肵܂B@Ȃĳ ۸т̎gp
** ̌ʂAǂȊԐړI܂͌ʂƂċN鑹Q≽̑QATMEL͌
** ӔCȂł傤B
*******************************************************************************
**
*/

#include "config.h"
#include "lib_window\window_lib.h"
#include "lib_window\hall_sensor_ISR.h"
#include "timer1_ovf_isr.h"

/*_____ S _________________________________________________________________*/

//! ΰيmpČo
//! ͈ : [DOWNWARD, UPWARD]
U8 hall_direction;

//! 2̍ŏIΰيm[Ԃ̎ԍ
signed int dv;		//!< xƓ

/*_____ I֐ _____________________________________________________________*/

#if defined(__ICCAVR__)						// IAR߲׎gp
  #pragma vector = TIMER0_OVF_vect
  __interrupt void TIMER0_OVF_ISR (void)
#elif defined (__AVR__)						// GCC߲׎gp
  ISR(TIMER0_OVF_vect)
#endif
  {
	ADCSRA |= 1<<ADEN | 1 << ADSC;			// A/DϊĕϊJn
  }

/*! @brief ΰٌʊmɐڑꂽAݕω荞ݻٰ
 *  ʒuƊd̍XV
 *
 * ΰٌʊm퐔ɏ]
 * - 2mgp: ʒuvẐ߂ɓ
 * - 1mgp: ߕɏ]ĈʒuvZ
 *
 * ̌AŌ2ΰيm[ɑ΂Ax(dv)vZ
 * dv<0 (x> 0)A擾dƈӖddXV
 */  
#if defined(__ICCAVR__)						// IAR߲׎gp
  #pragma vector = PCINT1_vect		// ATmega88pݕω荞޸
  __interrupt void hall_sensor_ISR (void)     
#elif defined (__AVR__)						// GCC߲׎gp
  ISR(PCINT1_vect)
#endif
{
  unsigned int vit;		// /1eۑAxvZp

						// 2̎Ԃ̎ԍ
  static U16 vitm1;		// Ōɔ(xƓ)
  static U16 vitm2;		// Ō1O̎(xƓ)

#if (HALL_SENSOR_NUMBER == 2)
  static U16 change=0;	// AIȕύX
#endif

  vit=TCNT1;
  TCNT1=0;				// /1

/* ---------------------- 2̊mgp ----------------------------------*/
#if (HALL_SENSOR_NUMBER == 2)
  if( _TEST_SENS() )					// _TEST_SENS: ɗmgp
  {
	if (hall_direction == DOWNWARD)		// ύXȂŁA
	  change=0;							// ύX
	else								// ύXŁA
	  change++;							// @\sSô߂ɘAIȕύXv
	hall_direction = DOWNWARD;			// 肵
	position++;							// ʒu
	save_k=0;							// ʒuύX׸ށAҰLKv
  }
  else
  {
	if (hall_direction == UPWARD)		// ύXȂŁA
	  change=0;							// ύX
	else								// ύXŁA
	  change++;							// @\sSô߂ɘAIȕύXv
	hall_direction = UPWARD;			// 肵
	if (position>0)						// ʒu=_ȊOŁA
	{
	  position--;						// ʒu
	  save_k=0;							// ʒuύX׸ށAҰLKv
	}
  }
  if (change > 30)						// AύX>30ŁA
  {										// ΰيm킪ؒfĂ邩܂B
	/* ُ邽߁Aɺނ}ĂB*/
	force_window_state(STOPING_STATE);	// d@~
	change=0;							// ύX
  }

/* ------------------------ 1̊mgp --------------------------------*/
#elif (HALL_SENSOR_NUMBER == 1)
  // ʒu߂ɖߕgp
  if ((direction == DOWNWARD) && (position < 0xFFFF))
  {
	position++;		// _͑: ʒuis
	save_k=0;		// ʒuXV: ҰLKv
  }
  else if ((direction == UPWARD) && (position > 0))
  {
	position--;		// _͑: ʒu
	save_k=0;		// ʒuXV: ҰLKv
  }
#else
#error "HALL_SENSOR_NUMBER (1 or 2) shall be defined in config .h"
#endif

/* ------------------------ vZ -----------------------------------------*/
  dv=vit-((vitm2 + vitm1)>>1);
  if ((dv<0) || (ref>current))	// 0(x0Ɠ)
  {
	ref = (current+ref)>>1;		// dXV
  }
  vitm2 = vitm1;
  vitm1 = vit;					// xۑ: ŏI̎ƂȂ邽
}

// ʒu擾: ʒuSɎ擾邽
U16 get_position(void)
{
  U16 temp;
  __disable_interrupt();
  temp = position;
  __enable_interrupt();
  return (temp);
}

// ʒuݒ: ʒuSɐݒ肷邽
void put_position(U16 position_temp)
{
  __disable_interrupt();
  position = position_temp;
  __enable_interrupt();
}

signed int get_hall_delta_period(void)
{
  signed int temp;
  __disable_interrupt();
  temp = dv;
  __enable_interrupt();
  return (temp);
}
