/*
**
*******************************************************************************
**
**				Copyright (c) 2005 - Atmel Corporation
**				L
**
** 	: ATmega88/168グ
** 	: main.c
** 	: ԑグ/ٰ̗pDCd@
**		  ATAVRAUTO200"pd"ATmega8̪Ŏgpׂ
**
** :		t:			:		:
** 1.0		2005N4		F.G.		쐬
**			2007N5		F.G.		AVRGCCxǉ
**
**				ȉ˭ނݒ肳ׂłB:-
**
**  -
**
** ATMEL - 2004
** SĂ̿ĳ ۸т͂ǂ̎̕ۏ؂Ȃ'󂻂̂܂'Œ񋟂܂BATMEL
** ͂ǂ̖ړIɑ΂Ă񋟂ꂽޗ̓K錾܂BATMEL͑SĂ̈Î
** Iȕۏ؁A̖ړIA\ANQɑ΂K܂݁A񋟂ꂽĳ
** ɊւSĂ̕ۏ؂Əłf肵܂B@Ȃĳ ۸т̎gp
** ̌ʂAǂȊԐړI܂͌ʂƂċN鑹Q≽̑QATMEL͌
** ӔCȂł傤B
*******************************************************************************
**
*/

/*_____ ݸٰ _____________________________________________________________*/

#include "config.h"
#include "eep_lib.h"
#include "filtre1.h"
#include "lib_window\window_lib.h"
#include "lib_window\hall_sensor_isr.h"

/*_____ ϸ _________________________________________________________________*/

#define TEMPO	(TIFR1 & (1 << TOV1)) == (1 << TOV1)

/*_____ ` ________________________________________________________________*/

/*_____ ^錾 ____________________________________________________________*/

void test_lin_buffer (signed char *, signed char *, U8 *);

/*_____ S ________________________________________________________________*/
extern volatile U8 osccal_start;

/**
 * @fn main
 *
 **/
int main (void)
{	
  signed char go_up_cmde = CMDE_NO_CMDE, go_down_cmde = CMDE_NO_CMDE;
  signed char state;
  static U8 no_anti_pinch = ANTI_PINCH_ENABLED;
  U8 init_status;

  CLKPR   = 0x80;
  CLKPR   = 0x00;				//  ۯOuȂ
  CONFIG_IO_PORTS();			// o߰Č`Ԑݒ
  SET_MOTOR_OFF();				// d@MOS-FET OFF
  init_schedule();				// LIN
  lin_init();					// LIN평
  init_window_peripherals();	// グpʰ޳
  __enable_interrupt();			// S̊荞݋

  init_status = Read_Eep_WindowParameters();

  while (1)						// JԂ
  {
	if (INIT_EEP_DONE != init_status)		// EEPROMׂłȂƎvƂA 
	{
	  // : ƒo邽߂ɊSȎ񂪎s܂B
	  while(INIT_END_INIT != init_status)	// JԂ: 
	  {
		if (ADCSRA & (1<<ADIF))
		{
		ADCSRA |= 1<<ADIF;					// A/Dϊ荞ݗv׸މ
		init_status = init_window_size_position(); 
		}

		l_sch_tick();						// LINɏՕXV
	  }
	}

	while(init_status != INIT_RE_INIT)	// JԂ
	{
	  l_sch_tick();							// LINɏՕXV
	  if (ADCSRA & (1<<ADIF))				// A/DϊŁA
	  {
		ADCSRA |= 1<<ADIF;					// A/Dϊ荞ݗv׸މ

		if((ADC & 0x200)== 0x200) current = mean_16(0);		// A/Dϊʁ0
		else current = mean_16(ADC);						// A/Dϊʁ0

		test_lin_buffer(&go_up_cmde,&go_down_cmde, &init_status);		// LINɏՕ疽ߎ擾
		state = window_ctrl(&go_up_cmde, &go_down_cmde, no_anti_pinch);	// Ƌݍݖh~ԋ@\

		SET_LIN_MOT_CURRENT(current);		// LINodXV
		SET_LIN_AP_STATE( state);			// LINoԍXV
		blocking_point(state);				// WQ_ԋ@\

		/* if(current > 250 && (state != OBSTRUCT_STATE || state!=PINCH_STATE || state!=REVERSE_STATE))
		{
		  // d: limite~20>11.5A
		  SET_RELAY_OFF();						// pd튪J
		  SET_MOTOR_OFF();						// d@MOS-FET OFF
		  force_window_state(STOPING_STATE);	// d@~
		}
		*/
		upload_eeprom_parameters();			// LINҰ ޳۰ނB
		save_window_parameters();			// d@~Ұۑ
	  }
	} // JԂ
  } // JԂ
}

void test_lin_buffer (signed char *upward, signed char *downward, U8 *cmde)
{
  static signed char up_cmde = CMDE_NO_CMDE, down_cmde = CMDE_NO_CMDE;

  if(CMD_LIN_GET_DOWNWARD() && CMD_LIN_GET_UPWARD())	// t
  {
    *cmde = INIT_RE_INIT;								// ďvꂽƂӖ܂B
  }
  else
  {
	if( CMD_LIN_GET_UPWARD() && up_cmde == CMDE_NO_CMDE)		// V
	{
	  up_cmde = CMDE_NEW_CMDE;
	  *upward = CMDE_NEW_CMDE;
	}
	else if (!CMD_LIN_GET_UPWARD()){
	  up_cmde = CMDE_NO_CMDE;
	}

	if( CMD_LIN_GET_DOWNWARD() && down_cmde == CMDE_NO_CMDE)	// V
	{
	  down_cmde = CMDE_NEW_CMDE;
	  *downward = CMDE_NEW_CMDE;
	}
	else if(!CMD_LIN_GET_DOWNWARD()){
	  down_cmde = CMDE_NO_CMDE;
	}
  }
}
