/*
**
*******************************************************************************
**
**
**				Copyright (c) 2004 - Atmel Corporation
**				L
**
** 	: ATmega48/88/168
** 	:
** 	: (ATAVRAUTO200"@Bpd"Ŏgpׂ)I/Oϸ
**
** :		t:			:		:
** 1.0		2006N1019	F.G.		쐬
**
**  -
**
** ATMEL - 2004
** SĂ̿ĳ ۸т͂ǂ̎̕ۏ؂Ȃ'󂻂̂܂'Œ񋟂܂BATMEL
** ͂ǂ̖ړIɑ΂Ă񋟂ꂽޗ̓K錾܂BATMEL͑SĂ̈Î
** Iȕۏ؁A̖ړIA\ANQɑ΂K܂݁A񋟂ꂽĳ
** ɊւSĂ̕ۏ؂Əłf肵܂B@Ȃĳ ۸т̎gp
** ̌ʂAǂȊԐړI܂͌ʂƂċN鑹Q≽̑QATMEL͌
** ӔCȂł傤B
*******************************************************************************
**
*/

#ifndef _BOARD_H
#define _BOARD_H

/*_____ ` ________________________________________________________________*/

//---------------------------------------------------------------------------//
//							MCU߰Đ錾										 //
//---------------------------------------------------------------------------//

// ߰B
#define _LIN_RXD_A			0x01	// PB0(ICP1/CLKO/PCINT0)
#define _MOTOR_DIR_A		0x02	// PB1(OC1A/PCINT1)
#define _MOTOR_DIR_B		0x04	// PB2(OC1B/SS/PCINT2)
#define _MOSI				0x08	// PB3(MOSI/OC2A/PCINT3)
#define _MISO				0x10	// PB4(MISO/PCINT4)
#define _SCK				0x20	// PB5(SCK/PCINT5)
#define _PB6				0x40	// PB6(TOSC1/XTALL1/PCINT6)
#define _BOOT				0x80	// PB7(TOSC2/XTAL2/PCINT7)

// ߰C
#define _V_SHUNT			0x01	// PC0(ADC0/PCINT8)
#define _VBAT_D_MEASURE		0x02	// PC1(ADC1/PCINT9)
#define _HALL_1				0x04	// PC2(ADC2/PCINT10)
#define _HALL_2				0x08	// PC3(ADC3/PCINT11)
#define _PC4				0x10	// PC4(ADC4/SDA/PCINT12)
#define _PC5				0x20	// PC5(ADC5/SCL/PCINT13)
#define _NRESET				0x40	// PC6(RESET/PCINT14)

// ߰D
#define _LIN_RXD			0x01	// PD0(RXD/PCINT16)
#define _LIN_TXD			0x02	// PD1(TXD/PCINT17)
#define _LIN_SLEEP			0x04	// PD2(INT0/PCINT18)
#define _GREEN_LED			0x08	// PD3(INT1/OC2B/PCINT19)
#define _PD4				0x10	// PD4(T0/XCK/PCINT20)
#define _PD5				0x20	// PD5(T1/OC0B/PCINT21)
#define _V_SHUNT_REF		0x40	// PD6(AIN0/OC0A/PCINT22) 
#define _V_SHUNT_COMPARE	0x80	// PD7(AIN1/PCINT2)

//---------------------------------------------------------------------------//
//							グϸ									 //
//---------------------------------------------------------------------------//
#define TIMEOUT				( TCNT1 > 10000 )
#define _TEST_SENS()		((PINC & _HALL_1)&&(PINC & _HALL_2))||(!(PINC & _HALL_1)&&!(PINC & _HALL_2))

//---------------------------------------------------------------------------//
//							MCU苖/֎~ϸ								 //
//---------------------------------------------------------------------------//
#define ENABLE_LIN()		(DDRD |= _LIN_SLEEP ,  PORTD |=  _LIN_SLEEP)
//#define Linb_enable()		(DDRD |= _LIN_SLEEP ,  PORTD |=  _LIN_SLEEP)
#define DISABLE_LIN()		(DDRD |= _LIN_SLEEP ,  PORTD &=~ _LIN_SLEEP)

//---------------------------------------------------------------------------//
//							MCU߰Č`Ԑݒϸ								 //
//---------------------------------------------------------------------------//

#define  CONFIG_PORTB()		(DDRB   = _MISO | _MOTOR_DIR_A  | _MOTOR_DIR_B , PORTB =  _LIN_RXD_A )
#define  CONFIG_PORTC()		(DDRC   = 0x00,  PORTC  = 0x00 )
#define  CONFIG_PORTD()		(DDRD   = _LIN_TXD | _LIN_SLEEP | _GREEN_LED , PORTD  = _LIN_TXD | _LIN_RXD )

#define  CONFIG_IO_PORTS()	(CONFIG_PORTB(),CONFIG_PORTC() ,CONFIG_PORTD())

//---------------------------------------------------------------------------//
//							MCUo͐ݒϸ									 //
//---------------------------------------------------------------------------//
#define SET_GREEN_LED()			(PORTD  &=  _GREEN_LED )
#define SET_RELAY_OFF()			(PORTB  &=  ~(_MOTOR_DIR_A | _MOTOR_DIR_B))
#define SET_MOTOR_DIRECTION()	(PORTB  &=  ~_MOTOR_DIR_B, PORTB  |=  _MOTOR_DIR_A )
#define SET_LIN_TXD()			(PORTD  |=  _LIN_TXD ) 

#define SET_MOTOR_ON()								// ATAVARAUTO200͓d@쓮邽߂FET܂B

//---------------------------------------------------------------------------//
//							MCUoؾ ϸ									 //
//---------------------------------------------------------------------------//
#define RESET_LIN_TXD()			(PORTD  &=  ~_LIN_TXD ) 
#define RESET_MOTOR_DIRECTION()	(PORTB  &=  ~_MOTOR_DIR_A, PORTB  |=  _MOTOR_DIR_B )
#define RESET_GREEN_LED()		(PORTD  |=  _GREEN_LED )

#define SET_MOTOR_OFF()			SET_RELAY_OFF()		// ATAVARAUTO200͓d@쓮邽߂FET܂B

//---------------------------------------------------------------------------//
//							MCUo͐؂ւϸ								 //
//---------------------------------------------------------------------------//
#define TOGGLE_GREEN_LED()	(PORTD ^= _GREEN_LED )

//---------------------------------------------------------------------------//
//					MCUްނ܂͖߂Ɋ֘Aϸ						 //
//---------------------------------------------------------------------------//
#define _PUSH3_LIN			0x04
#define _PUSH4_LIN			0x08

#endif  /* _BOARD_H */
