//******************************************************************************
//! @file $RCSfile: can_lib.c,v $
//!
//! Copyright (c) 2006 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧ق͈ȉ̊֐ײ؂܂݂܂B
//!		   - CAN()
//!		   - AT90CAN128/64/32p
//!
//! ̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! ̧قAVRStudio-412462/WinAVR-20060125ŊmFĂ܂B
//!
//! @version $Revision: 3.10 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "can_lib.h"
#include "can_drv.h"

//_____ ` ___________________________________________________________________

//_____ ֐ ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn can_init
//!
//! CANBCANMObsԂɒu߂ɁACANӋ@\ؾĂ
//! ŁAޯ ݸނASRAMɊ蓖ĂꂽSĂڼ޽܂B
//!
//! @warning	CAN͒ڰт̊ԂCAN޽ŎMقŋ܂(ʰ
//!				@\)B
//!
//! @param	Mode (for "can_fixed_baudrate"ҰgpȂp)
//!			==0: 葬ްڰĂCANޯ ݸޕ]Jn
//!			==1: CANBTxڼ޽eANޯ ݸޕ]Jn
//!
//! @return	ްڰď
//!			==0: ޯ ݸތ`Ԑݒ蒲s
//!			==1: ްڰĐs
//!
//------------------------------------------------------------------------------
U8 can_init(U8 mode)
{
  if ((Can_bit_timing(mode))==0) return (0);	// "can_drv.h"ϸێQ
  can_clear_all_mob();							// "can_drv.c"̊֐Q
  Can_enable();									// "can_drv.h"ϸێQ
  return (1);
}

//------------------------------------------------------------------------------
//  @fn can_cmd
//!
//! ̊֐͍sׂ(MAMA~)𕪐͂CANLqq܂B
//! ̊֐͑M܂͎MpMObꍇɏ(CAN_CMD_ACCEPTED܂
//! CAN_CMD_REFUSED)Ԃ܂BMObꍇAp͌ōĎsȂ
//! Ȃ܂B
//! ̊֐͑M܂͎MpMObꍇCANLqq(MOB_PENDING
//! MOB_NOT_REACHED)XV܂B~sꂽꍇACANLqqԂ
//! STATUS_CLEAREDɐݒ肳܂B
//!
//! @param	st_cmd_t* - sׂICANLqq\̂Can_descriptor߲
//!
//! @return	CAN_CMD_ACCEPTED - ߂͎󂯓܂B
//!			CAN_CMD_REFUSED  - ߂͋ۂ܂B
//!
//------------------------------------------------------------------------------
U8 can_cmd(st_cmd_t* cmd)
{
  U8 mob_handle, cpt;
  U32 u32_temp;

  if (cmd->cmd == CMD_ABORT)
  {
	if (cmd->status == MOB_PENDING)
	{
	  // M܂͎M͖sĂ܂B
	  Can_set_mob(cmd->handle);
	  Can_mob_abort();
	  Can_clear_status_mob();		// mɂׂ!
	  cmd->handle = 0;
	}
	cmd->status = STATUS_CLEARED;
  }
  else
  {
	mob_handle = can_get_mob_free();
	if (mob_handle!= NO_MOB)
	{
	  cmd->status = MOB_PENDING;
	  cmd->handle = mob_handle;
	  Can_set_mob(mob_handle);
	  Can_clear_mob();

	  switch (cmd->cmd)
	  {
		//------------
		case CMD_TX:
		  if (cmd->ctrl.ide){ Can_set_ext_id(cmd->id.ext);}
		  else              { Can_set_std_id(cmd->id.std);}
		  for (cpt=0;cpt<cmd->dlc;cpt++) CANMSG = *(cmd->pt_data + cpt);
		  if (cmd->ctrl.rtr) Can_set_rtr();
			else Can_clear_rtr();
		  Can_set_dlc(cmd->dlc);
		  Can_config_tx();
		  break;
		//------------
		case CMD_TX_DATA:
		  if (cmd->ctrl.ide){ Can_set_ext_id(cmd->id.ext);}
		  else              { Can_set_std_id(cmd->id.std);}
		  for (cpt=0;cpt<cmd->dlc;cpt++) CANMSG = *(cmd->pt_data + cpt);
		  cmd->ctrl.rtr=0; Can_clear_rtr();
		  Can_set_dlc(cmd->dlc);
		  Can_config_tx();
		  break;
		//------------
		case CMD_TX_REMOTE:
		  if (cmd->ctrl.ide){ Can_set_ext_id(cmd->id.ext);}
		  else              { Can_set_std_id(cmd->id.std);}
		  cmd->ctrl.rtr=1; Can_set_rtr();
		  Can_set_dlc(cmd->dlc);
		  Can_config_tx();
		  break;
		//------------
		case CMD_RX:
		  u32_temp=0; Can_set_ext_msk(u32_temp);
		  Can_clear_rtrmsk();
		  Can_clear_idemsk();
		  Can_config_rx();
		  break;
		//------------
		case CMD_RX_DATA:
		  u32_temp=0; Can_set_ext_msk(u32_temp);
		  cmd->ctrl.rtr=0; Can_set_rtrmsk(); Can_clear_rtr();
		  Can_clear_idemsk();
		  Can_config_rx();
		  break;
		//------------
		case CMD_RX_REMOTE:
		  u32_temp=0; Can_set_ext_msk(u32_temp);
		  cmd->ctrl.rtr=1; Can_set_rtrmsk(); Can_set_rtr();
		  Can_clear_rplv();
		  Can_clear_idemsk();
		  Can_config_rx();
		  break;
		//------------
		case CMD_RX_MASKED:
		  if (cmd->ctrl.ide){ Can_set_ext_id(cmd->id.ext);}
		  else              { Can_set_std_id(cmd->id.std);}
		  u32_temp=~0; Can_set_ext_msk(u32_temp);
		  Can_clear_rtrmsk();
		  Can_set_idemsk();
		  Can_config_rx();
		  break;
		//------------
		case CMD_RX_DATA_MASKED:
		  if (cmd->ctrl.ide){ Can_set_ext_id(cmd->id.ext);}
		  else              { Can_set_std_id(cmd->id.std);}
		  u32_temp=~0; Can_set_ext_msk(u32_temp);
		  cmd->ctrl.rtr=0; Can_set_rtrmsk(); Can_clear_rtr();
		  Can_set_idemsk();
		  Can_config_rx();
		  break;
		//------------
		case CMD_RX_REMOTE_MASKED:
		  if (cmd->ctrl.ide){ Can_set_ext_id(cmd->id.ext);}
		  else              { Can_set_std_id(cmd->id.std);}
		  u32_temp=~0; Can_set_ext_msk(u32_temp);
		  cmd->ctrl.rtr=1; Can_set_rtrmsk(); Can_set_rtr();
		  Can_clear_rplv();
		  Can_set_idemsk();
		  Can_config_rx();
		  break;
		//------------
		case CMD_REPLY:
		  for (cpt=0;cpt<cmd->dlc;cpt++) CANMSG = *(cmd->pt_data + cpt);
		  u32_temp=0; Can_set_ext_msk(u32_temp);
		  cmd->ctrl.rtr=1; Can_set_rtrmsk(); Can_set_rtr();
		  Can_set_rplv();
		  Can_clear_idemsk();
		  Can_config_rx();
		  break;
		//------------
		case CMD_REPLY_MASKED:
		  if (cmd->ctrl.ide){ Can_set_ext_id(cmd->id.ext);}
		  else              { Can_set_std_id(cmd->id.std);}
		  for (cpt=0;cpt<cmd->dlc;cpt++) CANMSG = *(cmd->pt_data + cpt);
		  u32_temp=~0; Can_set_ext_msk(u32_temp);
		  cmd->ctrl.rtr=1; Can_set_rtrmsk(); Can_set_rtr();
		  Can_set_rplv();
		  Can_set_idemsk();
		  Can_config_rx();
		  break;
		//------------
		default:
		  // CMD_NONE܂͖߂̏ꍇ
		  cmd->status = STATUS_CLEARED;
		  break;
		//------------
	  } // switch (cmd ...
	} // if (mob_handle ...
	else
	{
	  cmd->status = MOB_NOT_REACHED;
	  return CAN_CMD_REFUSED;
	}
  } // else (CMD_ABORT)
  return CAN_CMD_ACCEPTED;
}

//------------------------------------------------------------------------------
//  @fn can_get_status
//!
//! ̊֐͖߂sꂽۂԂƂ܂B
//! M̏ꍇASĂCANүނ\̂Ɋi[܂B
//! ̊֐CANM(MOB_TX_COMPLETED,MOB_RX_COMPLETED,MOB_RX_COMPLETED_DLCW,
//! MOB_???_ERROR)XV܂B
//!
//! @param	st_cmd_t* CANLqq\߲̂
//!
//! @return	CAN_STATUS_COMPLETED		- M܂͎M͊܂B
//!			CAN_STATUS_NOT_COMPLETED	- M܂͎M͊܂łB
//!			CAN_STATUS_ERROR			- `Ԑݒ܂CANʐMłُ̈
//!
//------------------------------------------------------------------------------
U8 can_get_status (st_cmd_t* cmd)
{
  U8 a_status, rtn_val;

  a_status = cmd->status;
  if ((a_status==STATUS_CLEARED)||(a_status==MOB_NOT_REACHED)||(a_status==MOB_DISABLE))
  {
	return CAN_STATUS_ERROR;
  }

  Can_set_mob(cmd->handle);
  a_status = can_get_mob_status();

  switch (a_status)
  {
	case MOB_NOT_COMPLETED:
	  // cmd->status͍XV܂B
	  rtn_val = CAN_STATUS_NOT_COMPLETED;
	  break;
	//---------------
	case MOB_RX_COMPLETED:
	case MOB_RX_COMPLETED_DLCW:
	  cmd->dlc = Can_get_dlc();
	  can_get_data(cmd->pt_data);
	  cmd->ctrl.rtr = Can_get_rtr();
	  if (Can_get_ide())			// gڰтŁA
	  {
		cmd->ctrl.ide = 1;			// gڰ
		Can_get_ext_id(cmd->id.ext);
	  }
	  else // Wڰ
	  {
		cmd->ctrl.ide = 0;
		Can_get_std_id(cmd->id.std);
	  }
	  // MȂALqq̏ԗ̈:0x20
	  // DCLxŎMȂALqq̏ԗ̈:0xA0
	  cmd->status = a_status;
	  Can_mob_abort();				// MObJ
	  Can_clear_status_mob();		// MObؾ
	  rtn_val = CAN_STATUS_COMPLETED;
	  break;
	//---------------
	case MOB_TX_COMPLETED:
	  // MȂALqq̏ԗ̈:0x40
	  cmd->status = a_status;
	  Can_mob_abort();				// MObJ
	  Can_clear_status_mob();		// MObؾ
	  rtn_val = CAN_STATUS_COMPLETED;
	  break;
	//---------------
	default:
	  // MObُȂALqq̏ԗ̈:(2i)000b.scfa
	  cmd->status = a_status;
	  Can_mob_abort();				// MObJ
	  Can_clear_status_mob();		// MObؾ
	  rtn_val = CAN_STATUS_ERROR;
	  break;

  } // switch (a_status...
  return (rtn_val);
}
