/*
**
*******************************************************************************
**
**				Copyright (c) 2005 - Atmel Corporation
**				L
**
** 	: AT90CAN128/ATmega88グ
** 	: window_lib.c
** 	: ԑグƋݍݖh~
**
** :		t:			:		:
** 1.0		2005N6		F.G.		쐬
**
**				ȉ˭ނݒ肳ׂłB:-
**
**  -
**
** ATMEL - 2005
** SĂ̿ĳ ۸т͂ǂ̎̕ۏ؂Ȃ'󂻂̂܂'Œ񋟂܂BATMEL
** ͂ǂ̖ړIɑ΂Ă񋟂ꂽޗ̓K錾܂BATMEL͑SĂ̈Î
** Iȕۏ؁A̖ړIA\ANQɑ΂K܂݁A񋟂ꂽĳ
** ɊւSĂ̕ۏ؂Əłf肵܂B@Ȃĳ ۸т̎gp
** ̌ʂAǂȊԐړI܂͌ʂƂċN鑹Q≽̑QATMEL͌
** ӔCȂł傤B
*******************************************************************************
**
*/

/*_____ ݸٰ _____________________________________________________________*/

#include "window_lib.h"
#include "filtre1.h"
#include "eep_lib.h"
#include "lib_window\hall_sensor_ISR.h"
#include "timer1_ovf_isr.h"

/*_____ S ________________________________________________________________*/

un_eep_WindowParam eep;		//!< EEPROMҰ @ingroup Eeprom_storage

/* ----- Ƌݍݖh~pS̕ϐ ---- */
//! @defgroup control_ap Ƌݍݖh~Ұ
//! ̑S̕ϐ͑グ̐Ƌݍݖh~یɎgp܂B
//! @{

//! (߂ɏ])Ō̑쒆̑
//! ͈: [DOWNWARD, UPWARD]
U8 last_direction;

//! (߂ɏ])
//! ͈: [DOWNWARD, UPWARD]
U8 direction;

//! グ(@ref Window_stateB)
signed char ctrl_state = STOP_STATE;

//! ʒuɏՕ
//! ͈ [0`down]
//! 0͑ł̌_łB
//! down͋L^\ȍőΰيm[łB
U16 position;

//! vZꂽd(I(A)<->ADC~ADC)
//! ͈: [0`(肳ꂽdl)~(ADC)]
//! ͋ݍ݌ô߂ɓd~(ADCl)ƔrłB
//! hxƑdɏ]ČvZ܂B
U16 ref;

//! d: 肭߂ɎZ@phg()Ȃ΂Ȃ܂B
//! ͈ [0`(d~ADC)]
//! d(ref)lƔrׂłB
U16 current;

//! ݍ臒l: gp҂ɂ(N(ƭ)ŕϐȂ΂Ȃ܂B
//! EEPROMɉϐĂȂPINCH_THRESlɐݒ肳܂B
//! EEPROMɑ΂Ċi[/ČĂяo܂(@ref Pinches_detection)B
U8 pinch_threshold;

//! (d@A/DϊҰ)ɏ]ċݍ臒lW
//! ݍ݂͎擾dlƒڔr邽߂@ref pinch_threshold@ref gainpEEPROMҰǂݍٰ݂ɂČvZ܂B
U16 pinch;

//! ݍݒl߂邽߂̑S̗
U8 gain;
//! @}

//! ̒ォ狲ݍݖh~s܂łmmł̋
//! EEPROMgpA܂͊lɂĖ܂(@ref Window_areas)B
U8 h_max_mm;

//! ̒ォ狲ݍݖh~s܂łΰيm[ł̋
//! h_max_mmdown̕ϐpČvZ܂B
U8 h_max;

//! mmł̊J(gp҂ɂĖ܂B)
//! (@ref Window_areasB)
U16 window_height_mm;

//! ̒ォ狲ݍݖh~܂łmmł̋
//! EEPR0Mgp܂͊lɂĖ܂(@ref Window_areas)B
U16 h_detect_min_mm;

//! ̒ォ狲ݍݖh~܂ł(ΰيm[ł)
//! h_detect_min_mmdown̕ϐpČvZ܂B
U16  h_detect_min;

//! mmɑ΂ΰيm[(ǍDȐx߂8ōړA@ref Window_areasB)
U16 top_mm;

//! (肳ꂽ)ԗVђl(Kٰ(init_window_size_position())ɂ鏉ł̋tΰيm[
U16 backlash;

//! ォ܂ł̓Ԃΰيm[
//! Kٰ݂܂͎gp҂ɂĖ܂(@ref Window_areas)B
U16 down; 

//! WQ_SRAMi[\Ablocking_point()ٰ݂ɂĊǗ܂B
//! ͌oꂽSĂ̖WQ_܂݁A쎞ԂœK܂B
st_b_point_tab  block_point;

//! WQ_ꎞɏՕBblock_point\̂ɖWQ_ǉ܂͍XV邽߂ɑ쒆blocking_point()ٰ݂ɂĊǗ܂B
st_b_point point_temp;

//! グIɂ̈ʒun߂ĖWQ_\XV邽߂ɑグ̊JnʒuL܂B
U16 start_pos;

//! グIɂ̈ʒu܂ŖWQ_\XV邽߂ɑグ̊JnʒuL܂B
U16 stop_pos;

//! グI̖WQ_XVɎgp׸
U8 update=0;

/*_____ I֐ ____________________________________________________________*/

/*! @brief get_window_state ԕ
 *
 * @\̏ԂԂ܂B
 * @return	̏
 */
signed char get_window_state (void)
{
  return (ctrl_state);
}

/*! @brief force_window_state ԋ
 *
 * @\̏Ԃ܂B
 * @return	̏
 */
signed char force_window_state (signed char temp)
{
  ctrl_state=temp;
  return (ctrl_state);
}

/*! @brief get_h_detect_min ォ狲ݍݖh~܂ł̋
 *
 * @return	ݍݖh~ɂꍂx(ΰيm'tops'ł)
 */
U16 get_h_detect_min(void)
{
  return (h_detect_min);
}

/*! @brief get_h_max ォ狲ݍݖh~֎~܂ł̋
 *
 * @return	ݍݖh~ɂꍂx(ΰيm'tops'ł)
 */
U8 get_h_max(void)
{
  return (h_max);
}

/*! @brief Iɑ~ǍɒƒƎԗVт̌o܂B͓Kٰ݂łB
 *
 * I(init_stateINIT_END_INITłȂȂ)܂ŏJԂ𑖍s܂B
 * e۸ޕϊA(1ǂADIFؾĂ)ԋ@\s܂B
 *	- :
 *	  Jn܂B̏Ԃ͒ꌟołB
 *	- ꌟo:
 *	  ߓdĎ܂Bߓd͑ʒułƌ􂷂ƂɎ܂B
 *	  ̂ɁAʒu͂̍ől(0xFFFF)ɕύX܂B
 *	  ̏Ԃ͒㌟oɐݒ肳삪n܂܂B
 *	- ㌟o:
 *	  ̏Ԃ͉ߓdo܂B̒iKAʒuhall_sensor_ISRɂčXV܂(ɈړĂԂ͌܂)B
 *	  ߓd͑ʒułƌ􂷂ƂɎ܂B
 *	  āȀԂ͑~ҰvZłB
 *	- ҰvZ:
 *	  0xFFFFƌ݂̈ʒuԂ̍ʒu'down'Ɋi[܂B
 *	  ʒu0(_ʒu)ɐݒ肳܂B
 *	  ҰvZ邽߂ɎԗVю擾Jn܂B
 *	- @BIȎԗVъJn:
 *	  Vn߂܂B
 *	- :
 *	  グݍݖh~̈ɂ܂œǍɑ~ĎԗVю擾Jn܂B
 *	- ԗVю擾:
 *	  t삪s鎞ɎԗV(@BIȔ񒼐)܂B
 *	  ŝɓdƊp܂B̒iK͏I܂B
 * @warning
 *	- ֐ΰيm[ł̈ʒulXVhall_sensor_ISRɂĊ荞܂ׂłB
 *	- ֐͑SĂ̑삪sĂ܂ɂI܂B
 *
 * @param	Ȃ(S̕ϐgp)
 * @pre		O: <code>init_window_peripherals</code>Ă΂ׂłB
 */
U8 init_window_size_position()
{
  U8 returned_state;
  static U8 init_state = INIT_START_INIT;
  static U16 init_pos = 0;
  U16 temp16;
  U32 temp32;
  static signed char go_up_cmde=0, go_down_cmde=0;
  if((ADC & 0x200)== 0x200)current = mean_16(0);
  else current = mean_16(ADC);

  returned_state = window_ctrl(&go_up_cmde, &go_down_cmde, ANTI_PINCH_DISABLED);

  //---------------------------------
  blocking_point(returned_state);

  //---------------------------------
  switch (init_state)
  {
  case INIT_START_INIT:
	if ((returned_state != STOP_STATE) || (returned_state != STOPING_STATE))
	  force_window_state(STOPING_STATE);		// d@~

	if (returned_state == STOP_STATE)
	{	// Jn
	  go_down_cmde = CMDE_NEW_CMDE;				// : ő
	  init_state = INIT_DETECT_BOTTOM;
	  TCNT1 = 0;								// Ԓߌoؾ
	}
	break;
  //---------------------------------
  case INIT_DETECT_BOTTOM:						// ꌟoҋ@
	if( (current > 350) || (TIMEOUT && (current > 200)))
	{											// ꌟo
	  SET_MOTOR_OFF();							// d@MOS-FET OFF
	  put_position(0xFFFF);
	  go_down_cmde = CMDE_NO_CMDE;
	  go_up_cmde = CMDE_NO_CMDE;
	  init_state = INIT_START_TOP_DETECT;
	  erase_block_point();						// č\zOɖWQ_\
	}
	else if (returned_state == STOP_STATE)
	  go_down_cmde = CMDE_NEW_CMDE;
	break;
  //---------------------------------
  case INIT_START_TOP_DETECT:					// ႭȂׂd҂
	if (current < 5)							// d
	{
	  go_down_cmde = CMDE_NO_CMDE;
	  go_up_cmde = CMDE_NEW_CMDE;				// ㌟oJn
	  init_state = INIT_DETECT_TOP;
	  TCNT1 = 0;								// Ԓߌoؾ
	}
	break;
  //---------------------------------
  case INIT_DETECT_TOP:							// ㌟oҋ@
	if((current > 350) || (TIMEOUT&& (current > 200)))
	{											// ㌟o
	  SET_MOTOR_OFF();							// d@MOS-FET OFF
	  temp16 = get_position();
	  down = 0xFFFF - temp16;
	  block_point_set_origin (temp16);			// WQ_p㌴_ݒ
	  put_position(0);
	  force_window_state(STOPING_STATE);		// d@~
	  init_state = INIT_COMPUTE_PARAMS;			// ҰŠvZ
	}
	else if (returned_state == STOP_STATE)
	  go_up_cmde = CMDE_NEW_CMDE;
	break;
  //---------------------------------
  case INIT_COMPUTE_PARAMS:
	temp32 = (((U32)down<<8));					// top_mm: ΰيm[
	top_mm = (U16)(temp32/window_height_mm);	// mmɑ΂鴯ސ~256
	h_detect_min = (U16)(((U32)h_detect_min_mm*top_mm)>>8);
	h_max = (U8)(((U32)h_max_mm*top_mm)>>8);
	init_state = INIT_BACKLASH_START;			// JԂfAI
	break;
  //---------------------------------
  case INIT_BACKLASH_START:
	if ((returned_state != STOP_STATE) || (returned_state != STOPING_STATE))
	  force_window_state(STOPING_STATE);		// d@~

	if ((returned_state == STOP_STATE) && (current < 5))
	{	// Jn
	  go_down_cmde = CMDE_NEW_CMDE;				// : 얽
	  init_state = INIT_BACKLASH_DOWN;
	  TCNT1 = 0;								// Ԓߌoؾ
	}
	break;
  //---------------------------------
  case INIT_BACKLASH_DOWN:
	if (get_position() >= (h_detect_min>>1))
	{
	  if ((returned_state == STOP_STATE)&&(current < 5))
	  {
		init_state = INIT_BACKLASH_ACQUIRE;
		init_pos = get_position();
		go_up_cmde = CMDE_NEW_CMDE;				// : 얽
	  }
	  else
		force_window_state(STOPING_STATE);		// d@~
	}
	else if (returned_state != GO_DOWN_STATE)
	  go_down_cmde = CMDE_NEW_CMDE;				// : 얽
	break;
  //---------------------------------
  case INIT_BACKLASH_ACQUIRE:
	if (get_position() < (init_pos - (top_mm >> 3)))	// ő厕ԗV: 32mm
	{	// 擾~
	  if (returned_state == STOP_STATE)
	  {
		init_state = INIT_END_INIT;
	  }
	  else
		force_window_state(STOPING_STATE);		// d@~
	}
	else if (returned_state == STOP_STATE)
	  go_up_cmde = CMDE_NEW_CMDE;				// : 얽
	else if ((current - ref) > (pinch >> 2))	// n
	{ // ԗVт͈ȉ̂悤ɎnŒ`܂B
	  // - ύX
	  // - dXV(d-<ݍ/4)
	  backlash = init_pos - get_position();
	}
	break;
  //---------------------------------
  default:
	init_state = INIT_START_INIT;
	break;
  }
  return (init_state);
}

/*! @brief EEPROMɊi[ꂽҰ̓ǂݍ݂ƌ
 *
 * Ұݒ肷邽߂EEPROMǂ݁A炪ĂȂ͈ȉs܂B
 * - ҰpĂB
 * - Ұ̎/KKvƂ̏ԂԂ܂B
 *
 * @Returns	(@ref Init_return_statusB)
 */
U8 Read_Eep_WindowParameters(void)
{
  U8 i;
  U8 init_to_perform = INIT_EEP_DONE;
  U32 temp;
  U8 *eep_b_point_ptr;
  eep_b_point_ptr = (void *)&block_point;	// block_point\̂ւ߲

  // EEPROMpɏՕɕ
  for (i = 0; i < sizeof(eep); i++)
  {
	eep.U8_ptr[i] = EEPROM_read(i);
  }

  for (i = 0; i < sizeof(block_point); i++)
  {
	eep_b_point_ptr[i] = EEPROM_read(i + PT_NUM_ADR);
  }

  position          = eep.param.position;
  last_direction    = eep.param.last_direction;
  gain              = eep.param.gain;
  pinch_threshold   = eep.param.pinch_threshold;
  window_height_mm  = eep.param.window_height_mm;
  h_detect_min_mm   = eep.param.h_detect_min_mm;
  h_max_mm          = eep.param.h_max_mm;
  down              = eep.param.down;
  backlash          = eep.param.backlash;

  //------------ ʒuƗ̈Ұ̌/ ---------------
  if (  (position           == 0xFFFF)		// ʒu
	  ||(last_direction     == 0xFF)		// ŏI
	  ||(down               == 0xFFFF)		// l
	  ||(backlash           == 0xFFFF)		// ԗVь
	  ||(block_point.pt_num > PT_NUM_MAX))	// WQ_
  {
	// ɓK/wK@\v
	init_to_perform |= INIT_POSITION_REQUEST;
	// WQ_̈
	for (i = 0; i < sizeof(block_point); i++)
	  eep_b_point_ptr[i] = 0;
  }

  //------------ gpҰ̌/ -----------------------
  if (  (window_height_mm   == 0xFFFF)		// gp҂ɂĕϐȂ΂Ȃ܂B
	  ||(gain               == 0xFF)
	  ||(pinch_threshold    == 0xFF)
	  ||(h_detect_min_mm    == 0xFFFF)
	  ||(h_max_mm           == 0xFF))
  {
	// gp҂ɂĕϐȂ΂Ȃ܂B
	// (window_lib.hł̊l)
	window_height_mm = WINDOW_HEIGHT_MM;	// mmł̑
	gain = GAIN;							// 
	pinch_threshold = PINCH_THRES;			// ݍ臒l
	h_detect_min_mm = H_DETECT_MIN_MM;		// ݍݖh~܂ł̋
	h_max_mm = H_MAX_MM;					// ݍݖh~s܂ł̋
  }

  temp = (((U32)down<<8));					// top_mm: ΰيm[
  top_mm = (U16)(temp/window_height_mm);	// mmɑ΂[~256
  pinch = ((U16)gain*pinch_threshold) >> 5;	// ݍݒlvZ

  // ----------- Jn/ʒuƌ􂳂鑋グ --------
  if (INIT_EEP_DONE == init_to_perform)
  {
	h_detect_min = (U16)(((U32)h_detect_min_mm*top_mm)>>8);
	h_max = (U8)(((U32)h_max_mm*top_mm)>>8);
  }
  return (init_to_perform);
}

/*! @brief KvƂ鎞ɑグҰEEPROMɊi[
 *
 * sake_k׸ނɏ]Ұ\ƖWQ_\EEPROMɊi[
 * - sake_k׸ނ2ƓɁAۂɎgpĂҰi[܂B
 * - sake_k׸ނ3ƓɁAVҰi[Agpɏ㏑܂B
 * - ̑A܂B
 *
 * @warning	sake_kҰ߂2܂3łȂ΂Ȃ܂B̌׸ނ͉(1ɐݒ)܂B
 */
void save_window_parameters(void)
{
  U8 i;
  U8 *U8_ptr;
  U32 temp;
  U8 *eep_b_point_ptr;
  eep_b_point_ptr = (void *)&block_point;		// pointer to block_point\̂ւ߲

  if (save_k > 1 && ctrl_state == STOP_STATE)	// ~㖳((timer1_ovf)
  {
	// グ삳Ұi[Kv邩
	if (save_k==2)
	{
	  eep.param.position          = get_position();
	  eep.param.last_direction    = last_direction;
	  eep.param.gain              = gain;
	  eep.param.pinch_threshold   = pinch_threshold;
	  eep.param.window_height_mm  = window_height_mm;
	  eep.param.h_detect_min_mm   = h_detect_min_mm;
	  eep.param.h_max_mm          = h_max_mm;
	  eep.param.down              = down;
	  eep.param.backlash          = backlash;
	  U8_ptr = eep.U8_ptr;
	}
	// VҰ񋟂AEEPROMւ̊i[KvłB
	else if(save_k == 3)
	{
	  U8_ptr = eep.U8_ptr;		// ͗p߲

	  gain                      = eep.param.gain;
	  pinch_threshold           = eep.param.pinch_threshold;
	  window_height_mm          = eep.param.window_height_mm;
	  h_detect_min_mm           = eep.param.h_detect_min_mm;
	  h_max_mm                  = eep.param.h_max_mm;

	  temp = (((U32)down<<8));						// top_mm: ΰيm[
	  top_mm = (U16)(temp/window_height_mm);		// mmɑ΂[~256
	  pinch = ((U16)gain*pinch_threshold) >> 5;		// ݍݒlvZ

	}

	// EEPROMグҰL
	for (i = 0; i < sizeof(eep); i++)
	{
	  EEPROM_write(i, U8_ptr[i]);
	}
	// EEPROMグWQ_L
	for (i = 0; i < sizeof(block_point); i++)
	{
	  EEPROM_write(i + PT_NUM_ADR, eep_b_point_ptr[i]);
	}
	save_k=1;										// XV׸: Ұ͕ۑ܂B
  }
}

/*! @brief グǗ
 *
 * upward, downward, no_anti_pinch߂ɏ]đグǗ܂B
 * KvȎɑtɂ邽߂̑肵dƈʒuĎ܂B
 *
 * @warning	ݍݖh~OɑSsĂ܂Ƃۏ؂ĂB
 *			gpOA/DϊČʂhgȂ΂Ȃ܂B
 *
 * @param	*up_cmde		Jn܂͕񍐂̖(@ref window_ctrl_argB)
 * @param	*down_cmde		͈: CMDE_NO_CMDE, CMDE_NEW_CMDE, CMDE_PERFORMED
 * @param	no_anti_pinch	ݍݖh~̋/֎~ @ref window_ctrl_arg
 * @pre		O:<code>mean_16</code>Ă΂ł傤B
 * @return	(U8)@\(@ref Window_stateB)
 */
U8 window_ctrl(signed char *up_cmde,signed char *down_cmde,U8 no_anti_pinch)
{
  static U16 delay=0;
  static int k_init;
  U16 position = get_position();
  switch(ctrl_state)
  {
	//--------------------------------------------------------------------------
	case STOP_STATE:					// ~
	  SET_MOTOR_OFF();					// d@MOS-FET OFF
	  if((position!=k_init) || (delay>0))
	  {
		delay=0;
	  }
	  k_init=position;					// ʒuzu
	  last_direction=direction;			// @BIȎԗVтlɓ邽߂ɍŌ̑ۑ
	  if (*up_cmde == CMDE_NEW_CMDE)
	  {
		*up_cmde = CMDE_PERFORMED;
		if (position > (top_mm >> 7))	// ĳx(2mm)
		{
		  direction = UPWARD;			// 
		  RESET_MOTOR_DIRECTION();		// pdOFF
		  SET_MOTOR_ON();				// d@MOS-FET OFF
		  ctrl_state=START_UP_STATE;
		  delay=0;
		  TCNT1=0;						// xƎԒ߂̂߂ɏJn
		}
	  }
	  if (*down_cmde == CMDE_NEW_CMDE)
	  {
		*down_cmde= CMDE_PERFORMED;
		direction = DOWNWARD;			// 
		SET_MOTOR_DIRECTION();			// pdON
		//SET_MOTOR_ON();				// GO_DOWN_STATEœd@ON
		delay=0;
		ctrl_state=GO_DOWN_STATE;
		TCNT1=0;						// xƎԒ߂̂߂ɏJn
	  }

	  break;
	//--------------------------------------------------------------------------
	case START_UP_STATE:				// 
	  if (no_anti_pinch != ANTI_PINCH_DISABLED)
	  {
		if(   (position < (k_init - backlash))
		   || (position < (k_init - (backlash >> 2))
			   &&last_direction == UPWARD) )	// n(ԗV)
		{
		  start_pos=position;			// WQ_ʒuXV̂ɎgpJnʒu
		  update=1;						// WQ_Ɏgp׸
		  ctrl_state=GO_UP_STATE;
		}
		else if (TIMEOUT)
		{
		  if (current>5)
			ctrl_state=PINCH_STATE;
		  else
		  {
			/* 񍐂邽߂ɂֺނ}ĂB*/
		  }
		}
	  }
	  else
	  {
		start_pos=position;				// ԗVђl߂̂ɎgpJnʒu
		ctrl_state = GO_UP_STATE;
	  }
	  if (*up_cmde == CMDE_NEW_CMDE || *down_cmde == CMDE_NEW_CMDE)
		ctrl_state=STOPING_STATE;
	  break;
	//--------------------------------------------------------------------------
	case GO_UP_STATE:					// WIȏis
	  if ( *up_cmde == CMDE_NEW_CMDE || *down_cmde == CMDE_NEW_CMDE)
		ctrl_state=STOPING_STATE;

	  if ( (current > (pinch + ref + get_block_point(position))) || TIMEOUT )
	  {
		if (position > h_max)
		{
		  ctrl_state=OBSTRUCT_STATE;
		}
		else if (position < (top_mm >> 7))	// ĳx(2mm)
		{
		  SET_MOTOR_OFF();
		  ctrl_state=STOP_STATE;
		}
		else if (TIMEOUT)
		{
		  SET_MOTOR_OFF();
		  ctrl_state=STOP_STATE;
		  if ( (position < h_max) && (position>0))	// @BIȒEŁA
			position--;					// ʒuC
			put_position(position);
		}
	  }
	  else if (position < (top_mm >> 7))	// ĳx(2mm)
	  {
		ctrl_state = STOPING_STATE;
	  }
	  else if (current<5 && position<h_detect_min)
	  { // dȂ(=)
		/* 񍐂邽߂ɂֺނ}ĂB*/
		if (delay>30)					// ݍݗ̈iKIɏis
		{
		  ctrl_state = STOPING_STATE;
		  delay=0;
		}
		else
		  delay++;
	  }

	  break;
	//--------------------------------------------------------------------------
	case OBSTRUCT_STATE:
	  if (*up_cmde == CMDE_NEW_CMDE)
		ctrl_state=STOPING_STATE;

	  // ݍݖh~K
	  if(   (position < h_detect_min)	// ݍݗ̈挟
		 && (position > h_max)
		 && (direction == UPWARD)		// 
		 && (no_anti_pinch == ANTI_PINCH_ENABLED))
	  {
		ctrl_state=PINCH_STATE;			// ݍݏv
	  }
	  else if (position < (top_mm >> 7))	// ĳE(1mm)
	  {
		SET_MOTOR_OFF();
		ctrl_state=STOP_STATE;
	  }
	  else if (TIMEOUT)					// Ԓ: xȂ
	  {
		SET_MOTOR_OFF();
		ctrl_state=STOP_STATE;
		if (position<h_max && position>0)	// @BIȒEŁA
		{
		  position--;					// ʒuC
		  put_position(position);
		}
	  }
	  else
		ctrl_state=GO_UP_STATE;
	  break;
	//--------------------------------------------------------------------------
	case PINCH_STATE:
	  SET_MOTOR_OFF();					// ݍ: d@~
	  if ((delay>5)&(current<5))		// xƒd
	  {
		ctrl_state=REVERSE_STATE;
		SET_MOTOR_DIRECTION();			// pdOFF
		TCNT1=0;						// Ԓؾ
	  }
	  else
		delay++;
	  break;
	//--------------------------------------------------------------------------
	case REVERSE_STATE:					// ݍ: is
	  if (position<h_detect_min)
	  {
		direction=DOWNWARD;
		SET_MOTOR_ON();					// FET OFF
	  }
	  else
	  {
		ctrl_state=STOPING_STATE;
	  }
	  if(TIMEOUT)
		ctrl_state=STOPING_STATE;
	  break;
	//--------------------------------------------------------------------------
	case STOPING_STATE:					// ~v
	  SET_MOTOR_OFF();					// FET OFF
	  if (TIMEOUT)
	  {
		RESET_MOTOR_DIRECTION();		// pdOFF
		*up_cmde = CMDE_PERFORMED;		// S߂֎~邽߂ɉtɏՕ
		*down_cmde = CMDE_PERFORMED;
		ctrl_state=STOP_STATE;
	  }
	   break;
	//--------------------------------------------------------------------------
	case GO_DOWN_STATE:					// is
	  if(delay>20)						// pdʒuҋ@
		SET_MOTOR_ON();					// d@MOS-FET OFF
	  else
		delay++;

	  if (position>down)				// ~E
	  {
		if(*down_cmde == CMDE_NO_CMDE || TIMEOUT)
		{
		  SET_MOTOR_OFF();				// FET OFF
		  ctrl_state=STOPING_STATE;
		}
		else	// tOFF܂͎Ԓ߂܂ŉis
		{ // 蓮is(go_down)܂B

		  position=down;
		  put_position(position);
		}

	  }
	  else if (TIMEOUT)
	  {
		if (current>5)					// d@ڑĂ̂ۏ(d>0)
		{
		  position=down;				// : ʒu
		  put_position(down);
		  ctrl_state=STOPING_STATE;
		}
		else
		{
		  /* ΰيm펞ԒߌoƓdȂ񍐂邽߂ɂֺނ}ĂB*/
		  ctrl_state=STOPING_STATE;
		  SET_MOTOR_OFF();				// FET OFF
		}
	  }
	  if (*down_cmde == CMDE_NEW_CMDE || *up_cmde == CMDE_NEW_CMDE) 
	  {
		ctrl_state=STOPING_STATE;		// ~
	  }
	  break;
	//--------------------------------------------------------------------------
	default:
	  SET_MOTOR_OFF();					// d@MOS-FET OFF
	  ctrl_state=STOP_STATE;
  }
  return (ctrl_state);
}

/*! @brief WQ_oԋ@\
 *
 * WQ_oԋ@\Ǘ܂B͖WQ_̍ZƍXVɎgp܂B
 * 
 * @param	window_state͑グԋ@\œׂô߂ɕKvƂ܂B
 * 
 * @pre		OF<code>window_ctrl</code>Ă΂ł傤B
 */
U8 blocking_point(signed char window_state)
{
  static U8 point_state=NORMAL_STATE;	// WQ_̏
  U16 position=get_position();

  // WQ_Ǘ
  if (window_state == GO_UP_STATE)
  {
	switch(point_state)
	{
	  case NORMAL_STATE:
		if ((current-ref) > (pinch>>1) && position < h_detect_min)
		{
		  point_temp.origin=position;	// ʰ/WQ_ʒuۑ
		  update=1;
		  point_state = BLOCKING_STATE;
		}
		break;

	  case BLOCKING_STATE:
		if ( (current-ref) < (pinch/3))
		{
		  point_temp.end=position;		// ʰ/WQIʒuۑ
		  point_state = SORT_STATE;
		}
		break;

	  case SORT_STATE:
		update_point();
		point_state = NORMAL_STATE;
		break;

	  default:
		point_state = NORMAL_STATE;
		break;
    }
  }
  else if (window_state == STOPING_STATE)
  {
	stop_pos=position;
	point_state = NORMAL_STATE;
  }
  else if (window_state == STOP_STATE)
  {
	if (update==1)
	{
	  stop_pos=position;
	  clean_point();
	  update=0;
	}
	point_state = NORMAL_STATE;
  }

  return (point_state);
}

/*! @brief WQ_\ް̍쐬/XV
*/
U8 update_point (void)
{
  U8 i=0,j=0;
  while ((block_point.point[i].end>point_temp.origin) && (i < (PT_NUM_MAX -1)))
         i++;
  if ( i < PT_NUM_MAX)
  {
	if (block_point.point[i].origin<=point_temp.end)
	{ // VWQ_Aȍ~̌ʂړ
	  if (block_point.pt_num<PT_NUM_MAX-1)
	  {
		block_point.pt_num++;
		for(j=block_point.pt_num;j>i;j--)
		{
		  block_point.point[j].origin = block_point.point[j-1].origin;
		  block_point.point[j].end = block_point.point[j-1].end;
		  block_point.point[j].occ = block_point.point[j-1].occ;
		}
		block_point.point[i].origin = point_temp.origin;
		block_point.point[i].end = point_temp.end;
		block_point.point[i].occ = 2;
	  }

	}
	else
	{ // WQ_XV
	  block_point.point[i].origin = point_temp.origin;
	  block_point.point[i].end = point_temp.end;
	  block_point.point[i].occ += 2;
	  if (block_point.point[i].occ>=4)
		block_point.point[i].occ=5;
	}
  }
  else
  {
	// PT_NUM_MAXB: ȏWQ_QƂ܂B
	// sƂ܂B
  }
  return (0);
}

/*! @brief ^ꂽʒů֐ŕ\ŎQƂꂽ̖WQ_̎wW擾
 */
U8 get_table_indice (U16 position)
{
  U8 i=0;
  while (block_point.point[i].origin<position && i<PT_NUM_MAX &&block_point.point[i].origin!=0)		// Jnʒu̕\̎wW擾
	i++;
  return (i);
}

/*! @brief (N悤ɒ~)݂ȂWQ_̏
 */
void clean_point(void)
{
  U8 i=0,j,end;
  end = get_table_indice (start_pos);
  i = get_table_indice (stop_pos);
  while (i<block_point.pt_num && i<end)	// (ŌɈړ̈)\̗vf𑖍
  {
	block_point.point[i].occ--;
	if (block_point.point[i].occ==0)	// ް
	{
	  for (j=i;j<block_point.pt_num;j++)
	  {
		block_point.point[j].origin = block_point.point[j+1].origin;
		block_point.point[j].end = block_point.point[j+1].end;
		block_point.point[j].occ = block_point.point[j+1].occ;
	  }
	  block_point.point[j+1].origin=0;
	  block_point.point[j+1].end=0;
	  block_point.point[j+1].occ=0;
	  if (block_point.pt_num>0)
		block_point.pt_num--;
	}
	i++;
  }
}

/*! @brief ^ꂽʒuɑ΂WQ_lԂB
 *
 * ҰŒ񋟂ꂽʒuɖWQ_L^Ă鎞ɁAݍݒlɉZׂ臒lԂ܂B
 * Ȃ΁ÄʒuɖWQ_ȂL^A0Ԃ܂B
 *
 * @param	position	WQ_݂鉽ꂩ̈ʒu
 *
 * @returns	̓_ɑ΂WQ_臒l܂0
 */
U8 get_block_point(U16 position)
{
  U8 i,blocking_value=0;
  for(i=0;i<PT_NUM_MAX;i++)
  {
	if (position<=block_point.point[i].origin)
	{
	  if (position>=block_point.point[i].end)
	  {
		blocking_value = (pinch>>1);
		break;
	  }
	}
  }
  return (blocking_value);
}

/*! @brief SĂ̖WQ_\̗̈
 *
 * (SRAM)SĂ̖WQ_̈0
 */
void erase_block_point(void)
{
  U8 i, *b_point_ptr;
  b_point_ptr = (void *)&block_point;	// block_point\̂ւ߲
  for(i=0;i<sizeof(block_point);i++)
  {
	b_point_ptr[i] = 0;
  }
}

/*! @brief SĂ̖̂WQ_̊/_ʒuύX
 * K(񏉊)ɗLp: _m
 * 
 * SĂ̊_̌_ƏÏʒuύX邽߂ɖWQ_\
 *
 * @param	origin	苎ׂۂ̌_ψ
 */
void block_point_set_origin(U16 origin)
{
  U8 i;
  for(i=0;i<PT_NUM_MAX;i++)
  {
	if (block_point.point[i].occ != 0)
	{
	block_point.point[i].origin -= origin;
	block_point.point[i].end    -= origin;
	}
  }
}

/*! @brief A/DϊA/Aݕω荞݂̂悤ȑグKvƂӋ@\
 * 
 * gpMCUɈˑ:
 * - ꊄ荞݂vƂ/0/1
 * - ݕω荞ݏ
 * - A/Dϊ평
 * 
 * @warning	gpMCUconfig.hŒ`ׂłB
 */
void init_window_peripherals(void)
{
#if defined (__ATmega88__) || defined (__ATmega168__) || defined (__AVR_ATmega88__) || defined (__AVR_ATmega168__)

  /* PCINT10ݕω荞ݏ */
  PCICR |= 1 << PCIE1;								// ݕω1Q(PCINT14`8)
  PCMSK1 |= 1 << PCINT10;							// PCINT10荞݋

  /* A/Dϊ평 */
  ADMUX |= 1 << REFS0;								// ϊʉEAAREF݂̊OݻAVCCAADC0I

  /* /1 */
  TCCR1B = TCCR1B | (1 << CS12);					// CS12=1, =2.097152b
  TIMSK1 |= 1<<TOIE1;								// /1ꊄ荞݋

  /* /0 */
  TCCR0B = TCCR0B | (1 << CS01)/*|(1 << CS00)*/;	// ۯ=fclock/8
  TIMSK0 |= 1<<TOIE0;								// /0ꊄ荞݋

#elif defined(__AT90PWM2__) || defined(__AT90PWM3__) || defined(__AVR_AT90PWM2__) || defined(__AVR_AT90PWM3__)
  // ΰٌʊmpO荞ݏ
  EICRA = 0x01;										// ㏸[
  EIMSK = 0x01;										// INT0

  // dpA/DϊƑ
  init_adc();
  init_amp0();

  // ds邽߂/0
  TCCR0B = TCCR0B | (1 << CS01)/*|(1 << CS00)*/;	// ۯ=fclock/8
  TIMSK0 |= 1<<TOIE0;								// /0ꊄ荞݋

  // 2bҰۑ邽߂/1
  TCCR1B = TCCR1B | (1 << CS12);					// CS12=1, =2.097152b
  TIMSK1 |= 1<<TOIE1;								// /1ꊄ荞݋

#else
  #error "Update init_window_peripherals() routine for your MCU"
#endif
}
