/*
**
*******************************************************************************
**
**				Copyright (c) 2003, 2004 - Atmel Corporation
**				L
**
** 	: AT90CAN128/ATmega88グ
** 	: filtre1.c
** 	: ʉhg(PAT90CAN128]p)
**
** :		t:			:		:
** 1.0		2004N210	F.G.		쐬
**
**				8MHzU
**
**  -
**
** ATMEL - 2003,2004
** SĂ̿ĳ ۸т͂ǂ̎̕ۏ؂Ȃ'󂻂̂܂'Œ񋟂܂BATMEL
** ͂ǂ̖ړIɑ΂Ă񋟂ꂽޗ̓K錾܂BATMEL͑SĂ̈Î
** Iȕۏ؁A̖ړIA\ANQɑ΂K܂݁A񋟂ꂽĳ
** ɊւSĂ̕ۏ؂Əłf肵܂B@Ȃĳ ۸т̎gp
** ̌ʂAǂȊԐړI܂͌ʂƂċN鑹Q≽̑QATMEL͌
** ӔCȂł傤B
*******************************************************************************
**
*/

// ȉł޼1hg:
// - ؒfg : fo
// - ̎ : Te
// =exp(-Te~2~3.14~fo);
// filter(i)= (1-)~signal(i)+~signal(i-1);
// łiuԍ̎Ai-1͒O̍̎

// ̎ : Te=256~64/8e6 , Te=0.002048s  Fe=488Hz // /0ɂė^
// fo=200HzŁA

// =0.0763606
// 256~=19.5483220

#include "filtre1.h"
#define alpha 20
#define m_alpha (256-alpha)

unsigned char filtre1 (unsigned char sig)
{
  static char sig_m1=0;		// MɊւ钼O̒l
  unsigned char temp;

  temp = (unsigned char)(((unsigned int)(m_alpha*sig) + (unsigned int)(alpha * sig_m1))>>8);

  sig_m1=temp;
  return(temp);
}

unsigned char mean_8(unsigned char sig)	// ŏI8`Bl̕
{
  static unsigned char sig_m[7]={0,0,0,0,0,0,0},i=0;
  i++;
  if(i>6)
	i=0;
  sig_m[i] = (unsigned char)((unsigned int)(sig_m[0]+sig_m[1]+sig_m[2]+sig_m[3]+sig_m[4]+sig_m[5]+sig_m[6]+sig)>>3);

  return(sig_m[i]);
}

unsigned int mean_16(unsigned int sig)	// ŏI8`Bl̕
{
  static unsigned int sig_m[7]={0,0,0,0,0,0,0},i=0;
  i++;
  if(i>6)
	i=0;
  sig_m[i] = (unsigned int)((unsigned long)(sig_m[0]+sig_m[1]+sig_m[2]+sig_m[3]+sig_m[4]+sig_m[5]+sig_m[6]+sig)>>3);

  return(sig_m[i]);
}
